> For the complete documentation index, see [llms.txt](https://docs.tonic.ai/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.tonic.ai/app/api/quick-start-guide/tonic-api-generator-assignment/generator-api-reference/generator-api-ref-finnish-pic.md).

# Finnish Personal Identity Code (FinnishPicGenerator)

The [Finnish Personal Identity Code](/app/generation/generators/generator-reference/finnish-personal-identity-code.md) generator generates a valid Finnish Personal Identity Code (PIC) that was generated during a specified date range.

## **Link object structure** <a href="#finnish-pic-link-structure" id="finnish-pic-link-structure"></a>

The Finnish Personal Identity Code generator does not support linking. It can be self-consistent, but not consistent with another column. You cannot configure differential privacy.

You configure the start and end dates for the date range.

```json

{
 "schema": "string",
 "table": "string",
 "column": "string",
 "path": "string",  //JSON fields only
 "dataType": "string",  //MongoDB, Amazon DynamoDB, and JSON fields only
 "metadata": {
   "presetId": "string",
   "generatorId": "FinnishPicGenerator",
   "isConsistent": boolean,
   "startDate": "timestamp",  //Only uses the date.
   "endDate": "timestamp",  //Only uses the date.  
   "encryptionProcessor": "x-on", //To use configured Structural data encryption
   "customValueProcessor": "string"  //If custom value processor applied
 }
}
```

## **Example replacement** <a href="#finnish-pic-example-replacement" id="finnish-pic-example-replacement"></a>

In the following example of the Finnish PIC generator, the PICs are for a date range between January 1, 1970 and December 31, 1990.

```json

{
 "name": "user_pic",
 "schema": "public",
 "table": "users",
 "links": [
   {
     "schema": "public",
     "table": "users",
     "column": "user_pic",
     "metadata": {
       "presetId": "FinnishPicGenerator",
       "generatorId": "FinnishPicGenerator",
       "startDate": "1979-01-01T00:00:00Z",
       "endDate": "1990-12-31T00:00:00Z",
       "isConsistent": false
     }
   }
 ]
}

```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.tonic.ai/app/api/quick-start-guide/tonic-api-generator-assignment/generator-api-reference/generator-api-ref-finnish-pic.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
